diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-l3-protocol.h ns-3.31/src/internet/model/ipv4-l3-protocol.h
--- ns-3.30.1/src/internet/model/ipv4-l3-protocol.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-l3-protocol.h	2020-06-27 17:38:30.000000000 -0700
@@ -101,7 +101,8 @@
     DROP_BAD_CHECKSUM,   /**< Bad checksum */
     DROP_INTERFACE_DOWN,   /**< Interface is down so can not send packet */
     DROP_ROUTE_ERROR,   /**< Route error */
-    DROP_FRAGMENT_TIMEOUT /**< Fragment timeout exceeded */
+    DROP_FRAGMENT_TIMEOUT, /**< Fragment timeout exceeded */
+    DROP_DUPLICATE  /**< Duplicate packet received */
   };
 
   /**
@@ -229,8 +230,8 @@
    * \param [in] interface
    */
   typedef void (* SentTracedCallback)
-    (const Ipv4Header & header, Ptr<const Packet> packet, uint32_t interface);
-   
+      (const Ipv4Header & header, Ptr<const Packet> packet, uint32_t interface);
+
   /**
    * TracedCallback signature for packet transmission or reception events.
    *
@@ -242,7 +243,7 @@
    * and will be changed to \c Ptr<const Ipv4> in a future release.
    */
   typedef void (* TxRxTracedCallback)
-    (Ptr<const Packet> packet, Ptr<Ipv4> ipv4, uint32_t interface);
+      (Ptr<const Packet> packet, Ptr<Ipv4> ipv4, uint32_t interface);
 
   /**
    * TracedCallback signature for packet drop events.
@@ -256,10 +257,10 @@
    * and will be changed to \c Ptr<const Ipv4> in a future release.
    */
   typedef void (* DropTracedCallback)
-    (const Ipv4Header & header, Ptr<const Packet> packet,
-     DropReason reason, Ptr<Ipv4> ipv4,
-     uint32_t interface);
-   
+      (const Ipv4Header & header, Ptr<const Packet> packet,
+          DropReason reason, Ptr<Ipv4> ipv4,
+          uint32_t interface);
+
 protected:
 
   virtual void DoDispose (void);
@@ -297,6 +298,16 @@
   virtual bool GetWeakEsModel (void) const;
 
   /**
+   * \brief Decrease the identification value for a dropped or recursed packet
+   * \param source source IPv4 address
+   * \param destination destination IPv4 address
+   * \param protocol L4 protocol
+   */
+  void DecreaseIdentification (Ipv4Address source,
+                               Ipv4Address destination,
+                               uint8_t protocol);
+
+  /**
    * \brief Construct an IPv4 header.
    * \param source source IPv4 address
    * \param destination destination IPv4 address
@@ -308,13 +319,13 @@
    * \return newly created IPv4 header
    */
   Ipv4Header BuildHeader (
-    Ipv4Address source,
-    Ipv4Address destination,
-    uint8_t protocol,
-    uint16_t payloadSize,
-    uint8_t ttl,
-    uint8_t tos,
-    bool mayFragment);
+      Ipv4Address source,
+      Ipv4Address destination,
+      uint8_t protocol,
+      uint16_t payloadSize,
+      uint8_t ttl,
+      uint8_t tos,
+      bool mayFragment);
 
   /**
    * \brief Send packet with route.
@@ -415,14 +426,6 @@
   bool ProcessFragment (Ptr<Packet>& packet, Ipv4Header & ipHeader, uint32_t iif);
 
   /**
-   * \brief Process the timeout for packet fragments
-   * \param key representing the packet fragments
-   * \param ipHeader the IP header of the original packet
-   * \param iif Input Interface
-   */
-  void HandleFragmentsTimeout ( std::pair<uint64_t, uint32_t> key, Ipv4Header & ipHeader, uint32_t iif);
-
-  /**
    * \brief Make a copy of the packet, add the header and invoke the TX trace callback
    * \param ipHeader the IP header that will be added to the packet
    * \param packet the packet
@@ -470,6 +473,8 @@
   TracedCallback<const Ipv4Header &, Ptr<const Packet>, uint32_t> m_sendOutgoingTrace;
   /// Trace of unicast forwarded packets
   TracedCallback<const Ipv4Header &, Ptr<const Packet>, uint32_t> m_unicastForwardTrace;
+  /// Trace of multicast forwarded packets
+  TracedCallback<const Ipv4Header &, Ptr<const Packet>, uint32_t> m_multicastForwardTrace;
   /// Trace of locally delivered packets
   TracedCallback<const Ipv4Header &, Ptr<const Packet>, uint32_t> m_localDeliverTrace;
 
@@ -492,12 +497,46 @@
 
   SocketList m_sockets; //!< List of IPv4 raw sockets.
 
+  /// Key identifying a fragmented packet
+  typedef std::pair<uint64_t, uint32_t> FragmentKey_t;
+
+  /// Container for fragment timeouts.
+  typedef std::list< std::tuple <Time, FragmentKey_t, Ipv4Header, uint32_t > > FragmentsTimeoutsList_t;
+  /// Container Iterator for fragment timeouts..
+  typedef std::list< std::tuple <Time, FragmentKey_t, Ipv4Header, uint32_t > >::iterator FragmentsTimeoutsListI_t;
+
+  /**
+   * \brief Process the timeout for packet fragments
+   * \param key representing the packet fragments
+   * \param ipHeader the IP header of the original packet
+   * \param iif Input Interface
+   */
+  void HandleFragmentsTimeout (FragmentKey_t key, Ipv4Header & ipHeader, uint32_t iif);
+
+  /**
+   * \brief Set a new timeout "event" for a fragmented packet
+   * \param key the fragment identification
+   * \param ipHeader the IPv4 header of the fragmented packet
+   * \param iif input interface of the packet
+   * \return an iterator to the inserted "event"
+   */
+  FragmentsTimeoutsListI_t SetTimeout (FragmentKey_t key, Ipv4Header ipHeader, uint32_t iif);
+
+  /**
+   * \brief Handles a fragmented packet timeout
+   */
+  void HandleTimeout (void);
+
+  FragmentsTimeoutsList_t m_timeoutEventList;  //!< Timeout "events" container
+
+  EventId m_timeoutEvent;  //!< Event for the next scheduled timeout
+
   /**
    * \brief A Set of Fragment belonging to the same packet (src, dst, identification and proto)
    */
   class Fragments : public SimpleRefCount<Fragments>
   {
-public:
+  public:
     /**
      * \brief Constructor.
      */
@@ -534,7 +573,19 @@
      */
     Ptr<Packet> GetPartialPacket () const;
 
-private:
+    /**
+     * \brief Set the Timeout iterator.
+     * \param iter The iterator.
+     */
+    void SetTimeoutIter (FragmentsTimeoutsListI_t iter);
+
+    /**
+     * \brief Get the Timeout iterator.
+     * \returns The iterator.
+     */
+    FragmentsTimeoutsListI_t GetTimeoutIter ();
+
+  private:
     /**
      * \brief True if other fragments will be sent.
      */
@@ -545,17 +596,42 @@
      */
     std::list<std::pair<Ptr<Packet>, uint16_t> > m_fragments;
 
+    /**
+     * \brief Timeout iterator to "event" handler
+     */
+    FragmentsTimeoutsListI_t m_timeoutIter;
   };
 
   /// Container of fragments, stored as pairs(src+dst addr, src+dst port) / fragment
-  typedef std::map< std::pair<uint64_t, uint32_t>, Ptr<Fragments> > MapFragments_t;
-  /// Container of fragment timeout event, stored as pairs(src+dst addr, src+dst port) / EventId
-  typedef std::map< std::pair<uint64_t, uint32_t>, EventId > MapFragmentsTimers_t;
+  typedef std::map< FragmentKey_t, Ptr<Fragments> > MapFragments_t;
 
   MapFragments_t       m_fragments; //!< Fragmented packets.
   Time                 m_fragmentExpirationTimeout; //!< Expiration timeout
-  MapFragmentsTimers_t m_fragmentsTimers; //!< Expiration events.
 
+  /// IETF RFC 6621, Section 6.2 de-duplication w/o IPSec
+  /// RFC 6621 recommended duplicate packet tuple: {IPV hash, IP protocol, IP source address, IP destination address}
+  typedef std::tuple <uint64_t, uint8_t, Ipv4Address, Ipv4Address> DupTuple_t;
+  /// Maps packet duplicate tuple to expiration time
+  typedef std::map<DupTuple_t, Time> DupMap_t;
+
+  /**
+   * Registers duplicate entry, return false if new
+   * \param [in] p Possibly duplicate packet.
+   * \param [in] header Packet \pname{p} header.
+   * \return True if this packet is a duplicate
+   */
+  bool UpdateDuplicate (Ptr<const Packet> p, const Ipv4Header &header);
+  /**
+   * Remove duplicate packet entry
+   * \param [in] iter Iterator into duplicate map to remove
+   */
+  void RemoveDuplicates (void);
+
+  bool                m_enableDpd;    //!< Enable multicast duplicate packet detection
+  DupMap_t            m_dups;         //!< map of packet duplicate tuples to expiry event
+  Time                m_expire;       //!< duplicate entry expiration delay
+  Time                m_purge;        //!< time between purging expired duplicate entries
+  EventId             m_cleanDpd;     //!< event to cleanup expired duplicate entries
 };
 
 } // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-list-routing.cc ns-3.31/src/internet/model/ipv4-list-routing.cc
--- ns-3.30.1/src/internet/model/ipv4-list-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-list-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -75,7 +75,7 @@
   NS_LOG_FUNCTION (this << stream);
   *stream->GetStream () << "Node: " << m_ipv4->GetObject<Node> ()->GetId () 
                         << ", Time: " << Now().As (unit)
-                        << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+                        << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
                         << ", Ipv4ListRouting table" << std::endl;
   for (Ipv4RoutingProtocolList::const_iterator i = m_routingProtocols.begin ();
        i != m_routingProtocols.end (); i++)
@@ -292,7 +292,7 @@
 bool 
 Ipv4ListRouting::Compare (const Ipv4RoutingProtocolEntry& a, const Ipv4RoutingProtocolEntry& b)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (a.first << a.second << b.first << b.second);
   return a.first > b.first;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-routing-table-entry.cc ns-3.31/src/internet/model/ipv4-routing-table-entry.cc
--- ns-3.30.1/src/internet/model/ipv4-routing-table-entry.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-routing-table-entry.cc	2020-06-27 17:38:30.000000000 -0700
@@ -96,7 +96,7 @@
 Ipv4RoutingTableEntry::IsHost (void) const
 {
   NS_LOG_FUNCTION (this);
-  if (m_destNetworkMask.IsEqual (Ipv4Mask::GetOnes ()))
+  if (m_destNetworkMask == Ipv4Mask::GetOnes ())
     {
       return true;
     }
@@ -121,7 +121,7 @@
 Ipv4RoutingTableEntry::IsDefault (void) const
 {
   NS_LOG_FUNCTION (this);
-  if (m_dest.IsEqual (Ipv4Address::GetZero ()))
+  if (m_dest == Ipv4Address::GetZero ())
     {
       return true;
     }
@@ -146,7 +146,7 @@
 Ipv4RoutingTableEntry::IsGateway (void) const
 {
   NS_LOG_FUNCTION (this);
-  if (m_gateway.IsEqual (Ipv4Address::GetZero ()))
+  if (m_gateway == Ipv4Address::GetZero ())
     {
       return false;
     }
@@ -173,14 +173,14 @@
                                           Ipv4Address nextHop,
                                           uint32_t interface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (dest << nextHop << interface);
   return Ipv4RoutingTableEntry (dest, nextHop, interface);
 }
 Ipv4RoutingTableEntry 
 Ipv4RoutingTableEntry::CreateHostRouteTo (Ipv4Address dest,
                                           uint32_t interface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (dest << interface);
   return Ipv4RoutingTableEntry (dest, interface);
 }
 Ipv4RoutingTableEntry 
@@ -189,7 +189,7 @@
                                              Ipv4Address nextHop,
                                              uint32_t interface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (network << networkMask << nextHop << interface);
   return Ipv4RoutingTableEntry (network, networkMask, 
                                 nextHop, interface);
 }
@@ -198,7 +198,7 @@
                                              Ipv4Mask networkMask,
                                              uint32_t interface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (network << networkMask << interface);
   return Ipv4RoutingTableEntry (network, networkMask, 
                                 interface);
 }
@@ -206,7 +206,7 @@
 Ipv4RoutingTableEntry::CreateDefaultRoute (Ipv4Address nextHop, 
                                            uint32_t interface)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (nextHop << interface);
   return Ipv4RoutingTableEntry (Ipv4Address::GetZero (), Ipv4Mask::GetZero (), nextHop, interface);
 }
 
@@ -351,13 +351,12 @@
 }
 
 Ipv4MulticastRoutingTableEntry 
-Ipv4MulticastRoutingTableEntry::CreateMulticastRoute (
-  Ipv4Address origin, 
-  Ipv4Address group, 
-  uint32_t inputInterface,
-  std::vector<uint32_t> outputInterfaces)
+Ipv4MulticastRoutingTableEntry::CreateMulticastRoute (Ipv4Address origin,
+                                                      Ipv4Address group,
+                                                      uint32_t inputInterface,
+                                                      std::vector<uint32_t> outputInterfaces)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (origin << group << inputInterface << outputInterfaces);
   return Ipv4MulticastRoutingTableEntry (origin, group, inputInterface, outputInterfaces);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-static-routing.cc ns-3.31/src/internet/model/ipv4-static-routing.cc
--- ns-3.30.1/src/internet/model/ipv4-static-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-static-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -697,7 +697,7 @@
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", Ipv4StaticRouting table" << std::endl;
 
   if (GetNRoutes () > 0)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv4-static-routing.h ns-3.31/src/internet/model/ipv4-static-routing.h
--- ns-3.30.1/src/internet/model/ipv4-static-routing.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv4-static-routing.h	2020-06-27 17:38:30.000000000 -0700
@@ -238,37 +238,18 @@
  * output network interface indices over which packets matching the conditions
  * are sent.
  *
- * Typically there are two main types of multicast routes:  routes of the 
- * first kind are used during forwarding.  All of the conditions must be
- * explicitly provided.  The second kind of routes are used to get packets off
- * of a local node.  The difference is in the input interface.  Routes for
- * forwarding will always have an explicit input interface specified.  Routes
- * off of a node will always set the input interface to a wildcard specified
- * by the index Ipv4RoutingProtocol::INTERFACE_ANY.
- *
- * For routes off of a local node wildcards may be used in the origin and
- * multicast group addresses.  The wildcard used for Ipv4Adresses is that 
- * address returned by Ipv4Address::GetAny () -- typically "0.0.0.0".  Usage
- * of a wildcard allows one to specify default behavior to varying degrees.
- *
- * For example, making the origin address a wildcard, but leaving the 
- * multicast group specific allows one (in the case of a node with multiple
- * interfaces) to create different routes using different output interfaces
- * for each multicast group.
- *
- * If the origin and multicast addresses are made wildcards, you have created
- * essentially a default multicast address that can forward to multiple 
- * interfaces.  Compare this to the actual default multicast address that is
- * limited to specifying a single output interface for compatibility with
- * existing functionality in other systems.
+ * Typically there are two main types of multicast routes:  routes used during
+ * forwarding, and routes used in the originator node.
+ * For forwarding, all of the conditions must be explicitly provided.
+ * For originator nodes, the route is equivalent to a unicast route, and
+ * must be added through `AddHostRouteTo`.
  * 
  * \param origin The Ipv4Address of the origin of packets for this route.  May
  * be Ipv4Address:GetAny for open groups.
  * \param group The Ipv4Address of the multicast group or this route.
  * \param inputInterface The input network interface index over which to 
- * expect packets destined for this route.  May be
- * Ipv4RoutingProtocol::INTERFACE_ANY for packets of local origin.
- * \param outputInterfaces A vector of network interface indices used to specify
+ * expect packets destined for this route.
+ * \param outputInterfaces A vector of network interface indexes used to specify
  * how to send packets to the destination(s).
  *
  * \see Ipv4Address
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-address-generator.cc ns-3.31/src/internet/model/ipv6-address-generator.cc
--- ns-3.30.1/src/internet/model/ipv6-address-generator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-address-generator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -677,7 +677,7 @@
   const Ipv6Prefix prefix,
   const Ipv6Address interfaceId)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (net << prefix << interfaceId);
 
   SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
   ->Init (net, prefix, interfaceId);
@@ -686,7 +686,7 @@
 Ipv6Address
 Ipv6AddressGenerator::NextNetwork (const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (prefix);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->NextNetwork (prefix);
@@ -695,7 +695,7 @@
 Ipv6Address
 Ipv6AddressGenerator::GetNetwork (const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (prefix);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->GetNetwork (prefix);
@@ -706,7 +706,7 @@
   const Ipv6Address interfaceId,
   const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (interfaceId << prefix);
 
   SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
   ->InitAddress (interfaceId, prefix);
@@ -715,7 +715,7 @@
 Ipv6Address
 Ipv6AddressGenerator::GetAddress (const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (prefix);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->GetAddress (prefix);
@@ -724,7 +724,7 @@
 Ipv6Address
 Ipv6AddressGenerator::NextAddress (const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (prefix);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->NextAddress (prefix);
@@ -742,7 +742,7 @@
 bool
 Ipv6AddressGenerator::AddAllocated (const Ipv6Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->AddAllocated (addr);
@@ -751,7 +751,7 @@
 bool
 Ipv6AddressGenerator::IsAddressAllocated (const Ipv6Address addr)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->IsAddressAllocated (addr);
@@ -760,7 +760,7 @@
 bool
 Ipv6AddressGenerator::IsNetworkAllocated (const Ipv6Address addr, const Ipv6Prefix prefix)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (addr << prefix);
 
   return SimulationSingleton<Ipv6AddressGeneratorImpl>::Get ()
          ->IsNetworkAllocated (addr, prefix);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/ipv6-end-point-demux.cc ns-3.31/src/internet/model/ipv6-end-point-demux.cc
--- ns-3.30.1/src/internet/model/ipv6-end-point-demux.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/ipv6-end-point-demux.cc	2020-06-27 17:38:30.000000000 -0700
@@ -31,12 +31,12 @@
     m_portFirst (49152),
     m_portLast (65535)
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 Ipv6EndPointDemux::~Ipv6EndPointDemux ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
   for (EndPointsI i = m_endPoints.begin (); i != m_endPoints.end (); i++)
     {
       Ipv6EndPoint *endPoint = *i;
